<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 04/11/2004 *
 * ===================                          Last change: 11/15/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-wernis.php                                   *
 * -------------------------------------------------------------------- *
 * Short description : Wernis extension                                 *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Auszahlung-Erweiterung                           *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Version of this extension
setThisExtensionVersion('0.0.3');

// Version history array (add more with , '0.1.0' and so on)
setExtensionVersionHistory(array('0.0', '0.0.1', '0.0.2', '0.0.3'));

switch (getExtensionMode()) {
	case 'register': // Do stuff when installation is running (modules.php?module=admin is called)
		// SQL commands to run
		addExtensionSql('DROP TABLE IF EXISTS `{?_MYSQL_PREFIX?}_user_wernis`');
		addExtensionSql("CREATE TABLE `{?_MYSQL_PREFIX?}_user_wernis` (
`id` BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
`userid` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0,
`wernis_account` VARCHAR(255) NOT NULL DEFAULT '',
`wernis_amount` FLOAT(20,5) UNSIGNED NOT NULL DEFAULT 0.00000,
`wernis_timestamp` VARCHAR(10) NOT NULL DEFAULT 0,
`wernis_type` ENUM('IN','OUT','FAILED') NOT NULL DEFAULT 'FAILED',
`wernis_api_message` TINYTEXT,
`wernis_api_status` VARCHAR(255) NULL DEFAULT NULL,
INDEX (`userid`),
PRIMARY KEY (`id`)
) ENGINE = {?_TABLE_TYPE?} CHARACTER SET utf8 COLLATE utf8_general_ci");

		// Confiuration
		addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_config` ADD wernis_min_payout BIGINT(20) UNSIGNED NOT NULL DEFAULT '40000'");
		addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_config` ADD wernis_min_withdraw BIGINT(20) UNSIGNED NOT NULL DEFAULT '5000'");
		addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_config` ADD wernis_api_id BIGINT(20) UNSIGNED NOT NULL DEFAULT 0");
		addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_config` ADD wernis_api_md5 VARCHAR(32) NOT NULL DEFAULT ''");
		addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_config` ADD wernis_api_url VARCHAR(255) NOT NULL DEFAULT 'http://www.wds66.com/api/'");

		// User data
		addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_user_data` ADD wernis_userid VARCHAR(6) NOT NULL DEFAULT ''");

		// Admin menu
		addAdminMenuSql('wernis', NULL, 'Wernis-Management','Konfiguration zur WDS66-API einstellen, Auszahlungen auflisten usw..', 15);
		addAdminMenuSql('wernis','config_wernis','WDS66-API-Einstellungen','Konfiguration zur WDS66-API einstellen.', 1);
		addAdminMenuSql('wernis','list_wernis','Wernis-Anfragen auflisten','Listet alle Wernis-Auszahlungsanfragen Ihrer Mitglieder auf.', 2);

		// Member menu
		addMemberMenuSql('main','wernis','Wernis-Ein-/Auszahlungen','N','Y', 11);

		// Guest menu
		addGuestMenuSql('main','wernis_portal','WDS66-News','N','Y', 7);
		break;

	case 'remove': // Do stuff when removing extension
		// SQL commands to run
		addExtensionSql('DROP TABLE IF EXISTS `{?_MYSQL_PREFIX?}_user_wernis`');
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_admin_menu` WHERE `action`='wernis'");
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE `what`='wernis'");
		addExtensionSql("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_guest_menu` WHERE `what`='wernis_portal'");
		break;

	case 'activate': // Do stuff when admin activates this extension
		// SQL commands to run
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_guest_menu` SET `visible`='Y', `locked`='N' WHERE `what`='wernis_portal' LIMIT 1");
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `visible`='Y', `locked`='N' WHERE `what`='wernis' LIMIT 1");
		break;

	case 'deactivate': // Do stuff when admin deactivates this extension
		// SQL commands to run
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_guest_menu` SET `visible`='N', `locked`='Y' WHERE `what`='wernis_portal' LIMIT 1");
		addExtensionSql("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `visible`='N', `locked`='Y' WHERE `what`='wernis' LIMIT 1");
		break;

	case 'update': // Update an extension
		switch (getCurrentExtensionVersion()) {
			case '0.0.1': // SQL queries for v0.0.1
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_config` ADD `wernis_payout_active` ENUM ('Y','N') NOT NULL DEFAULT 'Y'");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_config` ADD `wernis_withdraw_active` ENUM ('Y','N') NOT NULL DEFAULT 'Y'");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_config` ADD `wernis_payout_factor` FLOAT(20,5) UNSIGNED NOT NULL DEFAULT 1.00000");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_config` ADD `wernis_withdraw_factor` FLOAT(20,5) UNSIGNED NOT NULL DEFAULT 1.00000");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_config` ADD `wernis_payout_fee_percent` FLOAT(8,5) UNSIGNED NOT NULL DEFAULT 0.00000");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_config` ADD `wernis_withdraw_fee_percent` FLOAT(8,5) UNSIGNED NOT NULL DEFAULT 0.00000");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_config` ADD `wernis_payout_fee_fix` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0");
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_config` ADD `wernis_withdraw_fee_fix` BIGINT(20) UNSIGNED NOT NULL DEFAULT 0");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Ein-/Auszahlungsfunktion getrennt ein- und ausschaltbar, sowie mit Umrechungsfaktoren {?POINTS?}-&gt;Wernis versehen. Prozentualer Abzug als &quot;Betreibergeb&uuml;hr hinzugef&uuml;gt, was z.B. f&uuml;r Wechselstuben interessant ist.");
				break;

			case '0.0.2': // SQL queries for v0.0.2
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_config` ADD `wernis_pass_md5` VARCHAR(32) NOT NULL DEFAULT ''");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("Auszahlunsfunktion an die neue API 0.2-BETA angepasst. Demnach muss Ihr Wernis-Passwort beim Auszahlen benutzt werden und in Ihrem {?mt_word?} als MD5-Hash gespeichert werden.");
				break;

			case '0.0.3': // SQL queries for v0.0.3
				addExtensionSql("ALTER TABLE `{?_MYSQL_PREFIX?}_config` ADD `wernis_refid` INT(5) UNSIGNED ZEROFILL NOT NULL DEFAULT '00000'");

				// Update notes (these will be set as task text!)
				setExtensionUpdateNotes("WDS66-Username muss nun eintragen werden (API-Anpassung).");
				break;
		} // END - switch
		break;

	case 'modify': // When the extension got modified
		break;

	case 'test': // For testing purposes. For details see file inc/modules/admin/what-extensions.php, arround line 305.
		break;

	case 'init': // Do stuff when extension is initialized
		// Init array
		$GLOBALS['wernis_data'] = array();
		break;

	default: // Unknown extension mode
		logDebugMessage(__FILE__, __LINE__, sprintf("Unknown extension mode %s in extension %s detected.", getExtensionMode(), getCurrentExtensionName()));
		break;
} // END - switch

// [EOF]
?>
