<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 08/14/2004 *
 * ===================                          Last change: 10/22/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-admins_mails.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Control which admin shall receive which mail     *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Stellen Sie ein, welcher Admin welche Mail erh.  *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addYouAreHereLink('admin', __FILE__);

if (isFormSent('edit')) {
	// Check if entires are checked
	if (ifPostContainsSelections()) {
		// Add option for events
		$adminsList = generateOptionList('admins', 'id', 'login', '', 'email');
		$rows = '';
		foreach (postRequestParameter('sel') as $template => $sel) {
			// First of all load data from DB
			$result = SQL_QUERY_ESC("SELECT `admin_id`, `id` FROM `{?_MYSQL_PREFIX?}_admins_mails` WHERE `mail_template`='%s' ORDER BY `id` ASC",
				array($template), __FILE__, __LINE__);
			$OUT = '';
			$adminId2 = '0'; $id = '0';
			while ($content = SQL_FETCHARRAY($result)) {
				// @TODO Can this be rewritten to an API function?
				$OUT .= '<select name="admin_id[' . $content['id'] . ']" size="1" class="form_select">
<option value="0"';
				if ($content['admin_id'] == '0') $OUT .= ' selected="selected"';
				$OUT .= '>{--ADMINS_ALL_ADMINS--}</option>';
				if (isExtensionActive('events')) {
					$OUT .= '<option value="-1"';
					if ($content['admin_id'] == '-1') $OUT .= ' selected="selected"';
					$OUT .= '>{--ADMINS_TO_USER_EVENTS--}</option>';
				}
				$OUT .= generateOptionList('admins', 'id', 'login', $content['admin_id'], 'email');
				$OUT .= '</select>';

				// Transfer ids
				$adminId2 = $content['admin_id'];
				$id = $content['id'];
			} // END - while

			// Free memory
			SQL_FREERESULT($result);

			// Prepare content
			$content['id']            = $id;
			$content['mail_template'] = $template;
			$content['admins']        = $adminsList;

			if ($adminId2 > 0) {
				// Add form for an additional admin
				$OUT .= loadTemplate('admin_admins_mails_edit_form', true, $content);
			} // END - if

			// Save full rendered content
			$content['content'] = $OUT;

			// Start outputing line
			$rows .= loadTemplate('admin_admins_mails_edit_row', true, $content);
		} // END - foreach

		// Edit checked entries
		loadTemplate('admin_admins_mails_edit', false, $rows);
	} else {
		// Nothing selected
		loadTemplate('admin_settings_saved', false, '{--ADMINS_NO_MAIL_CHECKED--}');
	}
} else {
	// Load all assigned mails
	$result = SQL_QUERY("SELECT
	m.id, m.admin_id, a.login, m.mail_template
FROM
	`{?_MYSQL_PREFIX?}_admins_mails` AS m
LEFT JOIN
	`{?_MYSQL_PREFIX?}_admins` AS a
ON
	m.admin_id=a.id
WHERE
	(m.admin_id=a.id OR m.admin_id < 1) AND m.mail_template != ''
ORDER BY
	m.admin_id ASC,
	m.mail_template ASC", __FILE__, __LINE__);

	if (!SQL_HASZERONUMS($result)) {
		// Shall I change entries?
		if (isFormSent('change')) {
			// Init SQLs
			initSqls();

			// Ok, update database
			foreach (postRequestParameter('admin_id') as $id => $content['admin_id']) {
				// Secure ids
				$id  = bigintval($id);
				$content['admin_id'] = bigintval($content['admin_id']);

				// Update entry
				addSql(SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_admins_mails` SET admin_id=%s WHERE `id`=%s ORDER BY `id` LIMIT 1",
					array($content['admin_id'], $id), __FILE__, __LINE__, false));

				if (($content['admin_id'] < 1) && (isPostRequestParameterSet('template', $id))) {
					// Remove any other admin entries
					addSql(SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_admins_mails` WHERE mail_template='%s' AND id != '%s'",
					array(postRequestParameter('template', $id), $id), __FILE__, __LINE__, false));
				} // END - if

				if (postRequestParameter('admin_new', postRequestParameter('template', $id)) > 0) {
					// Add new admin
					addSql(SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_admins_mails` (admin_id, mail_template) VALUES ('%s','%s')",
					array($content['admin_id'], postRequestParameter('template', $id)), __FILE__, __LINE__, false));
				} // END - if
			} // END - foreach

			// Run all queries
			runFilterChain('run_sqls');

			// Query again...
			$result = SQL_QUERY("SELECT
	m.id, m.admin_id, a.login, m.mail_template
FROM
	`{?_MYSQL_PREFIX?}_admins_mails` AS m
LEFT JOIN
	`{?_MYSQL_PREFIX?}_admins` AS a
ON
	m.admin_id=a.id
WHERE
	(m.admin_id=a.id OR m.admin_id < 1) AND m.mail_template != ''
ORDER BY
	m.admin_id ASC,
	m.mail_template ASC", __FILE__, __LINE__);
		} // END - if

		// List found entries
		$OUT = '';
		while ($content = SQL_FETCHARRAY($result)) {
			// Load row template
			$OUT .= loadTemplate('admin_admins_mails_list_row', true, $content);
		} // END - while

		// Free result
		SQL_FREERESULT($result);

		// Load template
		loadTemplate('admin_admins_mails_list', false, $OUT);
	} else {
		// No entries found
		loadTemplate('admin_settings_saved', false, '{--ADMINS_MAILS_NO_ENTRIES--}');
	}
}

// [EOF]
?>
