<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 02/12/2005 *
 * ===================                          Last change: 02/12/2005 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_doubler.php                          *
 * -------------------------------------------------------------------- *
 * Short description : Points doubler                                   *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Punkte verdoppeln                                *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addYouAreHereLink('admin', __FILE__);

if (isFormSent()) {
	// Replace commata with decimal dot
	setPostRequestParameter('doubler_charge', convertCommaToDot(postRequestParameter('doubler_charge')));
	setPostRequestParameter('doubler_ref'   , convertCommaToDot(postRequestParameter('doubler_ref')));
	setPostRequestParameter('doubler_min'   , convertCommaToDot(postRequestParameter('doubler_min')));
	setPostRequestParameter('doubler_max'   , convertCommaToDot(postRequestParameter('doubler_max')));
	setPostRequestParameter('doubler_left'  , convertCommaToDot(postRequestParameter('doubler_left')));

	// Save settings
	adminSaveSettingsFromPostData();
} else {
	// Init all Y/N selections
	foreach (array('jackpot','own','sent_all') as $entry) {
		$content[$entry . '_y'] = '';
		$content[$entry . '_n'] = '';
		$content[$entry . '_' . strtolower(getConfig('doubler_' . $entry))] = ' checked="checked"';
	} // END - foreach

	// Init other selections
	foreach (array('send_mode_direct','send_mode_reset') as $entry) {
		$content[$entry] = '';
	} // END - foreach

	// Set current selections
	foreach (array('send_mode') as $entry) {
		$content[$entry . '_' . strtolower(getConfig('doubler_' . $entry))] = ' checked="checked"';
	} // END - foreach

	// Transfer options
	$content['form_selection'] = addMemberSelectionBox(getConfig('doubler_userid'), false, true, true, 'doubler_userid');

	// Number of rows to display (option lines!!!)
	foreach (array('new','pay','old') as $entry) {
		$content['display_' . $entry] = generateOptionList(
			'/ARRAY/',
			array(
				5,
				10,
				20,
				30,
				40,
				50,
				100
			), array(
				5,
				10,
				20,
				30,
				40,
				50,
				100
			),
			getConfig('doubler_display_' . $entry)
		);
	} // END - foreach

	// Timeout selection box or input box?
	$content['timeout_selection'] = createTimeSelections(getConfig('doubler_timeout')  , 'doubler_timeout'  , 'WDh');

	// Load template
	loadTemplate('admin_config_doubler', false, $content);
}

// [EOF]
?>
