<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 04/12/2004 *
 * ===================                          Last change: 12/01/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-payout.php                                  *
 * -------------------------------------------------------------------- *
 * Short description : Payout requests                                  *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Auszahlungsanfragen                              *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * Copyright (c) 2009, 2010 by Mailer Developer Team                    *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	// Don't call this directly!
	die();
} elseif (!isMember()) {
	// Not logged in
	redirectToIndexMemberOnlyModule();
}

// Add description as navigation point
addYouAreHereLink('member', __FILE__);

if ((!isExtensionActive('payout')) && (!isAdmin())) {
	loadTemplate('admin_settings_saved', false, generateExtensionInactiveNotInstalledMessage('payout'));
	return;
} // END - if

// Translate point into comma
$totalPoints = getTotalPoints(getMemberId());

if (!isGetRequestParameterSet('payout')) {
	// Load payout types
	$result = SQL_QUERY_ESC("SELECT
	`id`, `type`, `rate`, `min_points`, `allow_url`
FROM
	`{?_MYSQL_PREFIX?}_payout_types`
WHERE
	%s >= `min_points`
ORDER BY
	`type` ASC",
		array($totalPoints), __FILE__, __LINE__);
	if (!SQL_HASZERONUMS($result)) {
		// Free memory
		SQL_FREERESULT($result);

		// Check for his payouts
		$result_payouts = SQL_QUERY_ESC("SELECT
	p.id, p.payout_total, p.target_account, p.target_bank, t.type, p.payout_timestamp, p.status, t.allow_url AS allow, p.target_url AS url, p.link_text, p.banner_url AS banner
FROM
	`{?_MYSQL_PREFIX?}_user_payouts` AS p
LEFT JOIN
	`{?_MYSQL_PREFIX?}_payout_types` AS t
ON
	p.payout_id = t.id
WHERE
	p.userid = %s
ORDER BY
	p.payout_timestamp DESC",
			array(getMemberId()), __FILE__, __LINE__);
		if (!SQL_HASZERONUMS($result_payouts)) {
			// List all his requests
			$OUT = '';
			while ($content = SQL_FETCHARRAY($result_payouts)) {
				// Nothing entered must be secured in member/what-payputs.php !
				if ($content['allow'] == 'Y') {
					// Banner/Textlink views/clicks request
					if (!empty($content['banner'])) {
						// Banner
						$content['target_account'] = '<img src="' . $content['banner'] . '" alt="' . $content['link_text'] . '" title="' . $content['link_text'] . '" border="0" />';
					} else {
						// Textlink
						$content['target_account'] = $content['link_text'];
					}
					$content['target_bank'] = '<a href="' . generateDerefererUrl($content['url']) . '" target="_blank">{--CLICK_HERE--}</a>';
				} // END - if

				// Prepare data for the template
				$content['payout_timestamp'] = generateDateTime($content['payout_timestamp'], 2);

				// Load row template and switch colors
				$OUT .= loadTemplate('member_payout_row', true, $content);
			} // END - while

			// Load template
			loadTemplate('member_payout', false, $OUT);
		} // END - if

		// Free memory
		SQL_FREERESULT($result_payouts);

		// Output payout list
		outputPayoutList($totalPoints);
	} else {
		// No payout types setup
		loadTemplate('admin_settings_saved', false, '{--MEMBER_PAYOUT_SETUP_INCOMPLETE--}');
	}
} else {
	// Chedk if he can get paid by selected type
	$result = SQL_QUERY_ESC("SELECT `type`, `rate`, `min_points`, `allow_url` AS allow FROM `{?_MYSQL_PREFIX?}_payout_types` WHERE `id`=%s LIMIT 1",
		array(bigintval(getRequestParameter('payout'))), __FILE__, __LINE__);

	if (SQL_NUMROWS($result) == 1) {
		// id is valid so load the data
		$content = SQL_FETCHARRAY($result);

		// Calculate maximum value
		$max     = round($totalPoints * $content['rate'] - 0.5);
		$PAY_MAX = '0';

		// Calulcate points from submitted amount
		$points = '0';
		if (isPostRequestParameterSet('payout')) {
			$points  = bigintval(postRequestParameter('payout')) / $content['rate'];
			$PAY_MAX = $max / $content['rate'];
		}

		// Has enougth points to payout?
		if ($totalPoints >= $content['min_points']) {
			// Ok, he can get be paid
			if ((isFormSent()) && ($points <= $PAY_MAX) && ($points >= $content['min_points'])) {
				// Remember points in array
				setPostRequestParameter('payout_points', $points);
				setPostRequestParameter('type'         , $content['type']);

				// Subtract points from member's account
				subtractPoints('payout', getMemberId(), $points);

				// Add entry to his tranfer history
				if ($content['allow'] == 'Y') {
					// Banner/textlink ordered
					SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_user_payouts` (`userid`, `payout_total`, `payout_id`, `payout_timestamp`, `status`, `target_url`, `link_text`, `banner_url`)
VALUES (%s,%s,%s, UNIX_TIMESTAMP(), 'NEW','%s','%s','%s')",
					array(
						getMemberId(),
						bigintval(postRequestParameter('payout')),
						bigintval(getRequestParameter('payout')),
						postRequestParameter('turl'),
						postRequestParameter('link_text'),
						postRequestParameter('banner')
					), __FILE__, __LINE__);

					// Load templates
					$message_mem = loadEmailTemplate('member_payout_request_banner', postRequestArray(), getMemberId());
					if (isExtensionInstalledAndNewer('admins', '0.4.1')) {
						$adm_tpl = 'admin_payout_request_banner';
					} else {
						$message_adm = loadEmailTemplate('admin_payout_request_banner', postRequestArray(), getMemberId());
					}
				} else {
					// e-currency payout requested
					SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_user_payouts` (`userid`, `payout_total`, `target_account`, `target_bank`, `payout_id`, `payout_timestamp`, `status`, `password`)
VALUES (%s,%s,%s,'%s',%s, UNIX_TIMESTAMP(), 'NEW','%s')",
					array(
						getMemberId(),
						bigintval(postRequestParameter('payout')),
						bigintval(postRequestParameter('account')),
						postRequestParameter('bank'),
						bigintval(getRequestParameter('payout')),
						postRequestParameter('password')
					), __FILE__, __LINE__);

					// Load templates
					$message_mem = loadEmailTemplate('member_payout_request', postRequestArray(), getMemberId());
					$message_adm = loadEmailTemplate('admin_payout_request', postRequestArray(), getMemberId());
					$admin_tpl = '';

					// @TODO Rewrite this to a filter
					if (isExtensionInstalledAndNewer('admins', '0.4.1')) {
						$admin_tpl = 'admin_payout_request';
					} // END - if
				}

				// Generate task (we ignore the task id here)
				createNewTask('[payout:] {--ADMIN_PAYOUY_REQUEST_SUBJECT--}', $message_adm, 'PAYOUT_REQUEST', getMemberId());

				// Send out mails
				sendEmail(getMemberId(), '{--MEMBER_PAYOUT_REQUEST_SUBJECT--}', $message_mem);

				// To admin(s)
				sendAdminNotification('{--ADMIN_PAYOUY_REQUEST_SUBJECT--}', $admin_tpl, postRequestArray(), getMemberId());

				// Load template and output it
				loadTemplate('admin_settings_saved', false, '{--MEMBER_PAYOUT_REQUEST_SENT--}');
			} elseif ($content['allow'] == 'Y') {
				// Prepare content
				$content = array(
					'max'    => $max,
					'type'   => $content['type'],
					'payout' => bigintval(getRequestParameter('payout'))
				);

				// Generate banner order form
				loadTemplate('member_payout_form_banner', false, $content);
			} else {
				// Prepare content
				$content = array(
					'max'    => $max,
					'type'   => $content['type'],
					'payout' => bigintval(getRequestParameter('payout'))
				);

				// Generate normal form
				loadTemplate('member_payout_form', false, $content);
			}
		} else {
			// Not enougth points
			loadTemplate('admin_settings_saved', false, '{--MEMBER_PAYOUT_POINTS_NOT_ENOUGTH--}');
		}
	} else {
		// id is invalid
		loadTemplate('admin_settings_saved', false, '{--MEMBER_PAYOUT_ID_INVALID--}');
	}

	// Free result
	SQL_FREERESULT($result);
}

// [EOF]
?>
